<?php
    /*
    -----------------------------------------------------------
      zen-cart Open Source E-commerce
      Copyright (c) 2003 The zen-cart developers
      http://www.zen-cart.com/index.php
      Portions Copyright (c) 2003 osCommerce
    -----------------------------------------------------------
      www.alij.ne.jp Payment Module V.1.2
      alij.php
      Module created by ALIJ(www.alij.co.jp) - 24/12/2008
      Copyright (c) ALIJ
    -----------------------------------------------------------
    */

    class alij
    {

        const PRODUCTION_URL = "https://payment.alij.ne.jp/service/credit";
        const TEST_URL = "https://test-payment.alij.ne.jp/service/credit";

        var $code, $title, $description, $enabled;

        /**
         * alij constructor.
         */
        function alij()
        {
            global $order;

            $this->code = 'alij';
            $this->title = MODULE_PAYMENT_ALIJ_TEXT_TITLE;
            $this->description = MODULE_PAYMENT_ALIJ_TEXT_ADMINTITLE;
            $this->sort_order = MODULE_PAYMENT_ALIJ_SORT_ORDER;
            $this->enabled = ((MODULE_PAYMENT_ALIJ_STATUS == 'True') ? true : false);

            if (MODULE_PAYMENT_ALIJ_ORDER_MAIL == 'True') {
                $this->order_mail = '1';
            } else {
                $this->order_mail = '0';
            }

            if (MODULE_PAYMENT_ALIJ_USETEST == 'True') {
                $this->order_isUseTest = '1';
            } else {
                $this->order_isUseTest = '0';
            }

            if (MODULE_PAYMENT_ALIJ_USEQUICK == 'True') {
                $this->order_isUseQuick = '1';
            } else {
                $this->order_isUseQuick = '0';
            }

            if ((int)MODULE_PAYMENT_ALIJ_ORDER_STATUS_ID > 0) {
                $this->order_status = MODULE_PAYMENT_ALIJ_ORDER_STATUS_ID;
            }

            if ((int)MODULE_PAYMENT_ALIJ_ORDER_STATUSOK_ID > 0) {
                $this->order_statusok = MODULE_PAYMENT_ALIJ_ORDER_STATUSOK_ID;
            }

            if ((int)MODULE_PAYMENT_ALIJ_ORDER_STATUSNG_ID > 0) {
                $this->order_statusng = MODULE_PAYMENT_ALIJ_ORDER_STATUSNG_ID;
            }

            if (is_object($order)) $this->update_status();

            $this->email_footer = MODULE_PAYMENT_ALIJ_TEXT_EMAIL_FOOTER;
        }

        /**
         * update_status
         */
        function update_status()
        {
            global $order;
            global $db;

            if (($this->enabled == true) && ((int)MODULE_PAYMENT_ALIJ_ZONE > 0)) {
                $check_flag = false;
                $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_ALIJ_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
                if ($check_query->fields['zone_id'] < 1) {
                    $check_flag = true;
                } elseif ($check_query->fields['zone_id'] == $order->billing['zone_id']) {
                    $check_flag = true;
                }


                if ($check_flag == false) {
                    $this->enabled = false;
                }
            }
        }

        function javascript_validation()
        {
            return false;
        }

        function selection()
        {
            return array('id' => $this->code,
                'module' => $this->title,
                'fields' => array(array('title' => MODULE_PAYMENT_ALIJ_TEXT_PROCESS, 'field' => ''))
            );
        }

        function pre_confirmation_check()
        {
            return false;
        }

        function confirmation()
        {
            return array('title' => MODULE_PAYMENT_ALIJ_TEXT_DESCRIPTION);
        }

        function process_button()
        {
            return false;
        }

        function before_process()
        {
            return false;
        }

        function after_process()
        {
            // 送信パラメータの設定
            $parameters = http_build_query($this->setParameters());
            if ($this->order_isUseTest == '1') {
                $url = self::TEST_URL . '?' . $parameters;
            } else {
                $url = self::PRODUCTION_URL . '?' . $parameters;
            }
            zen_redirect($url);

        }

        function setParameters()
        {
            global $insert_id, $order;

            $zcVersion = PROJECT_VERSION_NAME . ' ' . PROJECT_VERSION_MAJOR . '.' . PROJECT_VERSION_MINOR;

            $arrParameter = array(
                'SiteId' => MODULE_PAYMENT_ALIJ_SITE_ID,
                'SitePass' => MODULE_PAYMENT_ALIJ_SITE_PASS,
                'SiteTransactionId' => $insert_id,
                'isSendMail' => $this->order_mail,
                'Amount' => ceil($order->info['total']),
                'tel' => preg_replace('/[^0-9]/', '', $order->billing['telephone']),
                'mail' => $order->customer['email_address'],
                'zen_cust_id' => $_SESSION['customer_id'],
                'sessid' => session_id(),
                'languages_id' => $_SESSION['languages_id'],
                'mode' => 'ALIJreturn',
                'PluginVersion' => '1.3',
                'PHPVersion' => phpversion(),
                'ZenCartVersion' => $zcVersion,
            );

            if ($this->order_isUseQuick == '1' && !empty($order->customer['telephone'])) {
                $arrParameter = $this->setQuickParameter($arrParameter, $order);
            }

            return $arrParameter;
        }

        function setQuickParameter($arrParameter, $order)
        {
            $quickParameter = array(
                'CustomerId' => $_SESSION['customer_id'],
                'CustomerPass' => $order->customer['telephone'],
            );

            return array_merge($arrParameter, $quickParameter);
        }

        function get_error()
        {
            return false;
        }

        function check()
        {
            global $db;
            if (!isset($this->_check)) {
                $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ALIJ_STATUS'");
                $this->_check = $check_query->RecordCount();
            }
            return $this->_check;
        }

        function install()
        {
            global $db;
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('クレジットカード決済を有効にする', 'MODULE_PAYMENT_ALIJ_STATUS', 'True', 'クレジットカードによる支払いを受け付けますか?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('サイトID', 'MODULE_PAYMENT_ALIJ_SITE_ID', '', 'サイトIDを入力してください。', '6', '0', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('サイトPASS', 'MODULE_PAYMENT_ALIJ_SITE_PASS', '', 'サイトpassを入力してください。', '6', '0', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('サーバーIP', 'MODULE_PAYMENT_ALIJ_SERVERIP', '0.0.0.0', 'Callbackの送信元IPアドレスと設定値が一致しているかのチェックが行われます。「59.106.8.27」を設定してください。チェックを行わない場合は、「0.0.0.0」で設定してください。', '6', '0', 'zen_cfg_select_option(array(\'0.0.0.0\', \'59.106.8.27\'), ', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('適用地域', 'MODULE_PAYMENT_ALIJ_ZONE', '0', '適用地域を選択すると、選択した地域のみで利用可能となります.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('表示の整列順', 'MODULE_PAYMENT_ALIJ_SORT_ORDER', '0', '表示の整列順を設定できます。数字が小さいほど上位に表示されます.', '6', '0', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('テスト環境を有効にする', 'MODULE_PAYMENT_ALIJ_USETEST', 'True', 'テスト環境を使用しますか?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('クイックチャージを有効にする', 'MODULE_PAYMENT_ALIJ_USEQUICK', 'False', '※クイックチャージをご希望の際は弊社までご連絡ください。', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('初期注文ステータス', 'MODULE_PAYMENT_ALIJ_ORDER_STATUS_ID', '0', '設定したステータスが受注時に適用されます.', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('決済成功ステータス', 'MODULE_PAYMENT_ALIJ_ORDER_STATUSOK_ID', '0', '設定したステータスが決済成功時に適用されます.', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('決済失敗ステータス', 'MODULE_PAYMENT_ALIJ_ORDER_STATUSNG_ID', '0', '設定したステータスが決済失敗時に適用されます.', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
            $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('決済結果を顧客にメール通知', 'MODULE_PAYMENT_ALIJ_ORDER_MAIL', 'True', '決済結果を顧客にメールで通知しますか?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");

            $language = $db->Execute("select languages_id from " . TABLE_LANGUAGES . " where name = 'Japanese'");
            $insert_language_id = $language->fields['languages_id'];
            $db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('97',$insert_language_id , '未清算状態です')");
            $db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('98',$insert_language_id , '決済が完了しました')");
            $db->Execute("insert into " . TABLE_ORDERS_STATUS . "(orders_status_id, language_id, orders_status_name) values ('99',$insert_language_id , '決済が失敗しました')");

        }

        function remove()
        {
            global $db;
            $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
            $db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_id=97");
            $db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_id=98");
            $db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_id=99");
        }

        function keys()
        {
            return array('MODULE_PAYMENT_ALIJ_STATUS', 'MODULE_PAYMENT_ALIJ_SITE_ID', 'MODULE_PAYMENT_ALIJ_SITE_PASS', 'MODULE_PAYMENT_ALIJ_SERVERIP', 'MODULE_PAYMENT_ALIJ_ZONE', 'MODULE_PAYMENT_ALIJ_USETEST', 'MODULE_PAYMENT_ALIJ_USEQUICK', 'MODULE_PAYMENT_ALIJ_ORDER_MAIL', 'MODULE_PAYMENT_ALIJ_ORDER_STATUS_ID', 'MODULE_PAYMENT_ALIJ_ORDER_STATUSOK_ID', 'MODULE_PAYMENT_ALIJ_ORDER_STATUSNG_ID', 'MODULE_PAYMENT_ALIJ_SORT_ORDER');
        }
    }

?>
